from __future__ import absolute_import

import unittest

from contextional.tests.tools import (
    SilentTestRunner,
    TestingTestProgram,
)
from contextional.tests.success import expected_stream_output


class TestSuccessResult(unittest.TestCase):

    @classmethod
    def setUpClass(cls):
        try:
            test_program = TestingTestProgram(
                module="contextional.tests.success",
                testRunner=SilentTestRunner,
                argv=["contextional/tests/test_success.py"],
                # exit=False,
            )
        except SystemExit:
            pass
        cls.test_results = test_program.result
        cls.stream_output = cls.test_results.test_run_output

    def test_tests_run_count(self):
        self.assertEqual(
            self.test_results.testsRun,
            6,
        )

    def test_failures_count(self):
        self.assertEqual(
            len(self.test_results.failures),
            0,
        )

    def test_errors_count(self):
        self.assertEqual(
            len(self.test_results.errors),
            0,
        )

    def test_stream_output(self):
        self.assertEqual(
            self.stream_output,
            expected_stream_output,
        )


if __name__ == '__main__':
    unittest.main()
